↓ 跳过正文
  1. Posts/

hdu 2048 神、上帝以及老天爷 (错排公式)

·504 字·2 分钟

hdu2048 题目链接

题意:n个人不放回的从一个有n个每个人对应id的卡片的盒子取一张卡片,取的正好和自己的对应就算中奖。求所有人都没有中奖的概率。

思路:错排。。。

复习了一下错排公式。。。d[n] = (n-1)*(d[n-1]+d[n-2]) (d[1]=0,d[2]=1)

然后求概率的时候。。惊讶得发现概率稳定在了36.79%(1/e)附近。。。

这是因为。。。错排还有一个公式:D(n) = n! [(-1)^2/2! + … + (-1)^(n-1)/(n-1)! + (-1)^n/n!].

求概率每次把n!除掉了。。剩下的。。其实就是e的泰勒展开,当x=-1时的值。

因为当n越大时。。这个概率越接近1/e

这道题里。。。在保留百分数的小数点两位的精度的条件下。。当n为7的时候。。答案就已经是36.79保持不变了。。。

代码实现
 1/* ***********************************************
 2Author :111qqz
 3Created Time :2016年07月27日 星期三 15时53分04秒
 4File Name :code/hdu/2048.cpp
 5************************************************ */
 6
 7#include <cstdio>
 8#include <cstring>
 9#include <iostream>
10#include <algorithm>
11#include <vector>
12#include <queue>
13#include <set>
14#include <map>
15#include <string>
16#include <cmath>
17#include <cstdlib>
18#include <ctime>
19#define fst first
20#define sec second
21#define lson l,m,rt<<1
22#define rson m+1,r,rt<<1|1
23#define ms(a,x) memset(a,x,sizeof(a))
24typedef long long LL;
25#define pi pair < int ,int >
26#define MP make_pair
27
28using namespace std;
29const double eps = 1E-8;
30const int dx4[4]={1,0,0,-1};
31const int dy4[4]={0,-1,1,0};
32const int inf = 0x3f3f3f3f;
33const int N=22;
34double d[N];
35double f[N];
36int n;
37int main()
38{
39	#ifndef  ONLINE_JUDGE
40	freopen("code/in.txt","r",stdin);
41  #endif
42
43	f[0] = 1;
44	for ( int i = 1; i < N ; i++) f[i] = f[i-1]*1.0*i;
45	d[1] = 0;
46	d[2] = 1;
47	for ( int i = 3 ; i < N ; i++) d[i] = 1.0*(i-1)*(d[i-1]+d[i-2]);
48
49	int T;
50	cin>>T;
51	while (T--)
52	{
53	    scanf("%d",&n);
54	    double ans = d[n]*100.0/f[n];
55	 //   cout<<"n:"<<n<<" d[n]:"<<d[n]<<" "<<f[n]<<endl;
56	    printf("%.2f%%\n",ans);
57
58	}
59
60  #ifndef ONLINE_JUDGE
61  fclose(stdin);
62  #endif
63    return 0;
64}

相关文章

bzoj1600 [Usaco2008 Oct]建造栅栏 (排列组合)

·845 字·2 分钟
勤奋的Farmer John想要建造一个四面的栅栏来关住牛们。他有一块长为n(4<=n<=2500)的木板,他想把这块本板切成4块。这四块小木板可以是任何一个长度只要Farmer John能够把它们围成一个合理的四边形。他能够切出多少种不同的合理方案。注意: *只要大木板的切割点不同就当成是不同的方案(像全排列那样),不要担心另外的特殊情况,go ahead。 *栅栏的面积要大于0. *输出保证答案在longint范围内。 *整块木板都要用完。

bc #77 div 2 B ||hdu 5651 xiaoxin juju needs help (排列组合,逆元)

·869 字·2 分钟
题目链接 题意;给出一个字符串,只由小写字母组成,可以任意排列,但是不能减少字符,问最多能得到多少个回文串,答案9+7 思路:排列组合题。 首先考虑无解的情况。统计出每个字母出现的次数,当字符串长度为奇数而且出现次数为奇数的字母的个数多于1个时无解,或者当字符串长度为偶数,出现次数为奇数的字母的个数多于0个时无解。 接下来,由于是回文串,只需要考虑len/2的情况,另一半是一一对应的。 其实就是一共有len/2的元素,其中有一些重复的,然后全排列。 多重元素的排列问题。 答案为(len/2)! % (cnt[1]!)% (cnt[2]!)…即可 哦要先把cnt降序排一下,只考虑cnt[i]>1的元素,然后因为是要考虑一半长度,所以每个cnt[i]/2 那一堆阶乘直接逆元搞就好了。。。。

hdu 2047 阿牛的EOF牛肉串 (递推)

·407 字·1 分钟
hdu 2047 题目链接 题意:一个由’E’ ‘O’ ‘F’ 组成的长度为n的字符串。‘O’不能相邻。。问方案数。。 思路:递推。。。蒙对了(误 考虑第n位,如果为’E’或者‘F’,此时对n-1位没有限制,答案为f[n-1],所以 一共是2×f[n-1]

hdu 2045 不容易系列之(3)—— LELE的RPG难题 (递推)

·385 字·1 分钟
hdu2045 题目链接 题意: 一串 方格,每个格子可以涂三种颜色,要求相邻的格子颜色不能相同,首尾格子也不能相同。 思路:递推。没推出来23333 我好菜啊.jpg. 考虑有n个格子。。那么假设第n-1个格子的颜色是a,根据第一个格子和第n-1个格子颜色是否相同分为两种情况。

hdu 2018 母牛的故事 (基础dp,记忆化搜索)

·623 字·2 分钟
hdu2018题目链接 题意:第1年有1头奶牛,每年生一头奶牛,新生的奶牛从生下来的第四年(包括生下来那年)也开始每年一头奶牛。 问第n年有多少头奶牛。 思路:最容易想到的。。递推一下。。。dp[i] = dp[i-1] + dp[i-3] (注意初始化不是一个dp[1]=1,而是dp[1..4]=1..4)